#include "jukebox.h"

char buf[1024];

play_raw_recording(char *filename)
{
  int r;
  int val;
  int audio_fd;
  int bp;
  FILE *fp;

  sprintf(buf,"%s/%s",RECFILE_PATH,filename);
  fp = fopen(buf,"r");
  if(!fp) {
     strcat(buf,".raw");
     fp = fopen(buf,"r");
     if(!fp) return -1;
  }

  printf("play_recording: opened %s\n",buf);

  audio_fd = open(DSPDEV,O_WRONLY);  
  if(audio_fd<0) {
     fprintf(stderr,"Can't open audio driver.\n");
     exit(999);
  }
  r = ioctl(audio_fd,SNDCTL_DSP_RESET,NULL);
  if(r>=0) {
     val = 16;
     r = ioctl(audio_fd,SNDCTL_DSP_SAMPLESIZE,&val);
  }
  if(r>=0) {
     val = AFMT_S16_LE;
     r = ioctl(audio_fd,SNDCTL_DSP_SETFMT,&val);
  }
  if(r>=0) {
     val = 1;
     r = ioctl(audio_fd,SNDCTL_DSP_STEREO,&val);
  }
  if(r>=0) {
     val = 22050;
     r = ioctl(audio_fd,SNDCTL_DSP_SPEED,&val);
  }
  if(r<0) {
     fprintf(stderr,"Sound device did not accept settings.\n");
     exit(999);
  }
  bp = 0;
  do {
     while(bp<sizeof(buf)) {
        int r = fread(buf+bp,1,sizeof(buf)-bp,fp);
        if(r<=0) break;
        bp += r;
     }
     write(audio_fd,buf,bp);
     bp = 0;
  } while(!feof(fp));
  fclose(fp);
  close(audio_fd);
  return 0;
}

play_recording(char *filename)
{
   if(play_raw_recording(filename)) {
      printf("raw play did not succeed, spawning mp3 player\n");
      sprintf(buf,"%s/%s.mp3",COMPRESSED_RECFILE_PATH,filename);
      execl(MPG123,MPG123,MPG123_DEV "-q",buf,0);
   }
   exit(0);
}
